//+------------------------------------------------------------------+
//|                                              iCustomTesterEA.mq4 |
//|                          Copyright  2012, Robert Hill aka MrPip |
//|                                                                  |
//|    The EA can be quickly modified to output values returned by   |
//|    custom indicators                                             |
//+------------------------------------------------------------------+
#include <stdlib.mqh>
// OR
extern bool a = false; // true;
extern bool b = false; // true;
extern bool c = false; // true;
extern bool d = false; // true;
extern bool e = false; // true; // false;
extern bool f = false; // true;
extern bool g = true;  // false;
// AND
extern bool h =  true;
extern bool i =  true;
extern bool j =  true;
extern bool k =  true;
extern bool l =  true; 
extern bool m =  true;
extern bool n =  false;

extern string  to="---Text Object Settings---";
extern bool    OutputTextToChart = true;
extern int     Y_OffSet = 60;
extern int 		TxtSize = 10;
extern color 	TxtColor  = White;

int            StatusY, Comment1Y, Comment2Y;
string         StatusLabel, Comment1Label, Comment2Label;

int init()
{
    DeleteExistingLabels();
    SetupLabels();
    ClearLabels();
     
   return(0);
}

int deinit()
{
  // ClearLabels();
  // DeleteExistingLabels();
 return(0);
}


//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
    
   bool res1, res2;
   string res1str, res2str;
   string pass, pass2;
    
   if (Comment1Y < Y_OffSet)
   {
     SetupLabels();
     ClearLabels();
     DeleteExistingLabels();
     SetupLabels();// Make sure label settings are OK
   }
      
   if (IsTesting() == false)
   {
     if (IsExpertEnabled() == false)
     {
      OutputStatusToChart("Expert is not enabled");
      return(0);
     }
   }
      
   if (!NewBar()) return(0);
   
// Modify here to test your code for compiler errors

           
   if (a || b || c || d  || e || f || g) res1 = true; else res1 = false;
   if (res1) pass = "PASS"; else pass = "FAIL";
   
   if (h && i && j && k && l && m && n) res2 = true; else res2 = false;
   if (res2) pass2 = "FAIL"; else pass2 = "PASS";

   res1str = BoolToStr(res1);
   res2str = BoolToStr(res2);
   OutputComment1ToChart("Result of OR test returns " + res1str + ": " + pass);
   OutputComment2ToChart("Result of AND test returns " + res2str + ": " + pass2);
   
   return(0);
//----
}

string BoolToStr(bool val)
{
   if (val) return("TRUE"); else return("FALSE");
}

bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}


void ClearLabels()
{
   string mComment = " ";
   
   OutputLabelToChart(StatusLabel, StatusY, TxtSize, TxtColor, mComment);
   OutputLabelToChart(Comment1Label, Comment1Y, TxtSize, TxtColor, mComment);
   OutputLabelToChart(Comment2Label, Comment2Y, TxtSize, TxtColor, mComment );
}

void DeleteExistingLabels()
{
   int objLabels = ObjectsTotal(OBJ_LABEL);
   string objName;
   
   if (objLabels > 0)
   {
      for (int i = objLabels; i >= 0;i--)
      {
         objName = ObjectName(i);
         if (StringFind(objName,Symbol() + "Status", 0) >= 0) { ObjectDelete(objName); continue; }  
         if (StringFind(objName,Symbol() + "Comment", 0) >= 0) { ObjectDelete(objName); continue; } 
      }
   }
}

void SetupLabels()
{
     StatusY = Y_OffSet;
     Comment1Y = StatusY + TxtSize + 4;
     Comment2Y = Comment1Y + TxtSize + 4;
	  StatusLabel = Symbol() + "Status";
	  Comment1Label = Symbol() + "Comment1";
	  Comment2Label = Symbol() + "Comment2";
}

void OutputLabelToChart(string LabelName, int LabelY, int LabelTxtSize, color LabelColor, string LabelStr)
{

  	if(ObjectFind(LabelName) != 0)
   {
   ObjectCreate(LabelName, OBJ_LABEL, 0, 0, 0);
	ObjectSet(LabelName, OBJPROP_CORNER, 0);
	ObjectSet(LabelName, OBJPROP_XDISTANCE, 20);
	ObjectSet(LabelName, OBJPROP_YDISTANCE, LabelY);
	}
	ObjectSetText(LabelName, LabelStr, LabelTxtSize, "Arial Bold", LabelColor);
}

void OutputStatusToChart(string mComment)
{
   OutputLabelToChart(StatusLabel, StatusY, TxtSize, TxtColor, mComment );
}

void OutputComment1ToChart(string mComment)
{
   OutputLabelToChart(Comment1Label, Comment1Y, TxtSize, TxtColor, mComment );
}

void OutputComment2ToChart(string mComment)
{
   OutputLabelToChart(Comment2Label, Comment2Y, TxtSize, TxtColor, mComment );
}
//+------------------------------------------------------------------+